package windowsPackage;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Observable;
import java.util.Observer;

import javax.swing.*;
import javax.swing.text.html.HTMLDocument.HTMLReader.IsindexAction;

public class CustomerSelect extends Observable implements Observer {
	private JFrame frame;
	private Container contentPane;
	private Search searchInstance;
	private JPanel panel;
	private Customer cm;
	private static CustomerSelect instance;
	
	private CustomerSelect(Booking bookingFrame, int i) {
		frame = new JFrame();
		contentPane = frame.getContentPane();
		panel = new JPanel();
		panel.setLayout(new BorderLayout());
		frame.setResizable(false);
		this.addObserver(bookingFrame);
		
		// stter instance til null nr vinduet lukkes, sledes at man kan bne vinduet igen pga. singleton
				frame.addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						instance = null;
					}
				});
		
		if(i == 1) {
			searchInstance = new Search(5, this, frame);
			panel.add(searchInstance.getTopPanel());
		}
		else if(i == 2) {
			cm = new Customer();
			cm.setPreferredSize(new Dimension(450, 275));
			panel.add(cm, BorderLayout.CENTER);
			panel.add(addCreateButton(), BorderLayout.SOUTH);
		}
		
		contentPane.add(panel);
		frame.setResizable(false);
		frame.pack();
		frame.setVisible(true);
	}
	
	public static CustomerSelect getInstance(Booking bookingFrame, int i) {
        if(instance == null)
            instance = new CustomerSelect(bookingFrame, i);
        return instance;
    }
	
	private JPanel addCreateButton() {
		JPanel buttonPanel = new JPanel();
		
		JButton createCustomer = new JButton("Opret");
		
		createCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
				setChanged();
				Database db = new Database();
				if(cm.verifyInput() == "true") {
					String cmd = "INSERT INTO Customers (FirstName, LastName, CPR, Adress1, Adress2, PhoneNumber, Mail, PassportNumber) VALUES('"  + cm.getInput() + "')";
					// metoden insertTravel skal benyttes for at f kundes oprettede ID.
					int id = 0;
					try {
						id = db.insertReturnKey(cmd);
					} catch (SQLException e1) {
						JOptionPane.showMessageDialog(null, "Der skete en fejl under oprettelsen af kunden. Fejlkode: " + e1);
						return;
					}
					String[] parts = cm.getInput().split("', '");
					String send = id + " " + parts[0] + " " + parts[1];
					notifyObservers(send);
					instance = null;
					frame.dispose();
				}
				else {
					JOptionPane.showMessageDialog(null, cm.verifyInput());
				}
				}
				catch(SQLException e1) {
					JOptionPane.showMessageDialog(null, "Du skal vre forbundet til internettet!");
				}
			}
		});
		
		buttonPanel.add(createCustomer);
		return buttonPanel;
	}

	@Override
	public void update(Observable arg0, Object arg1) {
		if(arg1 instanceof String) {
			setChanged();
			notifyObservers(arg1);
			instance = null;
			frame.dispose();
		}
		else {
			System.out.println("Error");
			JOptionPane.showMessageDialog(null, "Der skete en fejl :(");
			frame.dispose();
		}
	}

}
